package com.logicbig.example;


import reactor.core.publisher.Flux;
import reactor.core.scheduler.Schedulers;
import java.time.LocalTime;

public class Example1FlatMapDelayError {
    public static void main(String[] args) {
        Flux.just(1, 3, 5, 7)
            .flatMapDelayError(integer -> {
                System.out.println("-----------");
                if (integer == 5) {
                    throw new IllegalArgumentException("test exception");
                }
                return Flux.range(integer, integer * 2)
                           .subscribeOn(Schedulers.newParallel("myThread", 8));
            }, 4, 3).onErrorResume(throwable -> {
            System.out.println("-- error --");
            System.out.println(throwable);
            return Flux.just(20);
        })
            .subscribe(e -> System.out.println(e + " - " + Thread.currentThread().getName() + " - " + LocalTime.now()));
    }
}